$Title Maxwell
*-------------------------------------------------------------------------------
Sets             i  pocet mereni         
# /1*50/;
*-------------------------------------------------------------------------------
parameter
            fek(i) frekcence
/
@
/
     C(i) namereny parametr C(f)
/
@
/
   F(i) namereny parametr F(f)
/
@
/
;
parameter
           Re_k(i) realna osa Kelvin  ;
                   Re_k(i)=C(i);
parameter
           Im_k(i) imaginarni osa Kelvin  ;
                   Im_k(i)=F(i) * 2 * pi * fek(i) ;
parameters
              c1_i pocatecni nastrel parametru c1
              /
_A
/
              c2_i pocatecni nastrel parametru c2
              /
_B
/
              c3_i pocatecni nastrel parametru c3
              / 
_C
/
              k1_i pocatecni nastrel parametru k1
              /
_E
/
              k2_i pocatecni nastrel parametru k2
              /
_F
/
              k3_i pocatecni nastrel parametru k3
              /
_G
/
              c1_min minimln dovolen hodnota parametru c1
              /
_I
/
              c2_min minimln dovolen hodnota parametru c2
              /
_J
/
              c3_min minimln dovolen hodnota parametru c3
              /
_K
/
              k1_min minimln dovolen hodnota parametru k1
              /
_M
/
              k2_min minimln dovolen hodnota parametru k2
              /
_N
/
              k3_min minimln dovolen hodnota parametru k3
              /
_O
/
              c1_max maximln dovolen hodnota parametru c1
              /
_Q
/
              c2_max maximln dovolen hodnota parametru c2
              /
_R
/
              c3_max maximln dovolen hodnota parametru c3
              /
_S
/
              k1_max maximln dovolen hodnota parametru k1
              /
_U
/
              k2_max maximln dovolen hodnota parametru k2
              /
_V
/
              k3_max maximln dovolen hodnota parametru k3
              /
_W
/
;
*-------------------------------------------------------------------------------
Variables
                 c1 koeficient
                 c2 koeficient
                 c3 koeficient
                 k1 koeficient
                 k2 koeficient
                 k3 koeficient
                 Re_m(i) realna osa Maxwell
                 Im_m(i) imaginarni osa Maxwell   ;
Variables
                 z        ucelova funkce
;
*-------------------------------------------------------------------------------
Equations
                 ucel         ucelova funkce
                 maxwell_Re   vypocet realne casti
                 maxwell_Im   vypocet imaginarni casti
                 cmin1
                 cmin2
                 cmin3
                 kmin1
                 kmin2
                 kmin3
                 cmax1
                 cmax2
                 cmax3
                 kmax1
                 kmax2
                 kmax3
;

ucel.. z =g= sum((i),(Im_k(i)-Im_m(i))*(Im_k(i)-Im_m(i))/Im_k(i))+sum((i),(Re_k(i)-Re_m(i))*(Re_k(i)-Re_m(i))/Re_k(i)) ;

cmin1..  c1=g=c1_min;
cmin2..  c2=g=c2_min;
cmin3..  c3=g=c3_min;
kmin1..  k1=g=k1_min;
kmin2..  k2=g=k2_min;
kmin3..  k3=g=k3_min;
cmax1..  c1=l= c1_max;
cmax2..  c2=l= c2_max;
cmax3..  c3=l= c3_max;
kmax1..  k1=l= k1_max;
kmax2..  k2=l= k2_max;
kmax3..  k3=l= k3_max;


maxwell_Re(i)..  Re_m(i) =e=  (c1/(c1*c1+sqr(2*pi*fek(i))*k1*k1))/(sqr(c1/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+c2/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+c3/(c3*c3+sqr(2*pi*fek(i))*k3*k3))+sqr((2*pi*fek(i)*k1)/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+(2*pi*fek(i)*k2)/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+(2*pi*fek(i)*k3)/(c3*c3+sqr(2*pi*fek(i))*k3*k3)))
                          +   (c2/(c2*c2+sqr(2*pi*fek(i))*k2*k2))/(sqr(c1/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+c2/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+c3/(c3*c3+sqr(2*pi*fek(i))*k3*k3))+sqr((2*pi*fek(i)*k1)/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+(2*pi*fek(i)*k2)/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+(2*pi*fek(i)*k3)/(c3*c3+sqr(2*pi*fek(i))*k3*k3)))
                          +   (c3/(c3*c3+sqr(2*pi*fek(i))*k3*k3))/(sqr(c1/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+c2/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+c3/(c3*c3+sqr(2*pi*fek(i))*k3*k3))+sqr((2*pi*fek(i)*k1)/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+(2*pi*fek(i)*k2)/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+(2*pi*fek(i)*k3)/(c3*c3+sqr(2*pi*fek(i))*k3*k3)))               ;     c1.l=c1_i; c2.l=c2_i; c3.l=c3_i; k1.l=k1_i; k2.l=k2_i; k3.l=k3_i;

maxwell_Im(i)..  Im_m(i) =e=  ((2*pi*fek(i)*k1)/(c1*c1+sqr(2*pi*fek(i))*k1*k1))/(sqr(c1/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+c2/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+c3/(c3*c3+sqr(2*pi*fek(i))*k3*k3))+sqr((2*pi*fek(i)*k1)/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+(2*pi*fek(i)*k2)/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+(2*pi*fek(i)*k3)/(c3*c3+sqr(2*pi*fek(i))*k3*k3)))
                          +   ((2*pi*fek(i)*k2)/(c2*c2+sqr(2*pi*fek(i))*k2*k2))/(sqr(c1/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+c2/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+c3/(c3*c3+sqr(2*pi*fek(i))*k3*k3))+sqr((2*pi*fek(i)*k1)/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+(2*pi*fek(i)*k2)/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+(2*pi*fek(i)*k3)/(c3*c3+sqr(2*pi*fek(i))*k3*k3)))
                          +   ((2*pi*fek(i)*k3)/(c3*c3+sqr(2*pi*fek(i))*k3*k3))/(sqr(c1/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+c2/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+c3/(c3*c3+sqr(2*pi*fek(i))*k3*k3))+sqr((2*pi*fek(i)*k1)/(c1*c1+sqr(2*pi*fek(i))*k1*k1)+(2*pi*fek(i)*k2)/(c2*c2+sqr(2*pi*fek(i))*k2*k2)+(2*pi*fek(i)*k3)/(c3*c3+sqr(2*pi*fek(i))*k3*k3)))  ;     c1.l=c1_i; c2.l=c2_i; c3.l=c3_i; k1.l=k1_i; k2.l=k2_i; k3.l=k3_i;

*-------------------------------------------------------------------------------
option decimals=8;
option iterlim=900000000;
option reslim =900000000;

model Maxwell /all/;

*option nlp=conopt;
*option nlp=baron;
*option nlp=coinipopt;
*option nlp=coinos;
*option nlp=emp;
*option nlp=minos;
*option nlp=minos;

*option nlp=gamsbas;

_Z

*Maxwell.optfile=1;
*Maxwell.workfactor=500000;

solve Maxwell using nlp minimizing z;
display c1.l,c2.l,c3.l,k1.l,k2.l,k3.l,Re_m.l,Im_m.l;

file output1 /output1.dat/ ;
put output1;
loop((i), put fek(i) C(i) F(i) Re_m.l(i) Im_m.l(i) /);

file output2 /output2.dat/ ;
put output2;
put c1.l:<:3/
    c2.l:<:3/
    c3.l:<:3/
    k1.l:<:3/
    k2.l:<:3/
    k3.l:<:3/;
